﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO;
using System.Web.Services;
using Syncfusion.JavaScript.Models;
using System.Data.SqlClient;
using System.IO;
using System.Web.Script.Services;
using Syncfusion.JavaScript.Web;
using Syncfusion.JavaScript.DataSources;
using System.Collections;
using System.Windows.Forms;
using System.Web.Script.Serialization;
using Dapper;
public partial class Workpackages_Spreadsheet : DashPartPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
        }
    }
    [WebMethod()]
    [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
    public static object Data(DataManager value)
    {
        string dbConnectionStr = @"workspace";
        SqlConnection sqlCon = new SqlConnection(dbConnectionStr);
        SqlCommand sqlComm = new SqlCommand(@"SELECT [EXT_Workpackage_ID],[Workpackage_Code],[Name],[Project_ID],[EXT_Workpackage_Status_ID],[EXT_Workpackage_Type_ID],[Created_Date],
            [Last_Update_Time],[Last_Update_User]
      ,[Description]
      ,[Drawing_Requirements]
      ,[Materials]
      ,[Cutting_List]
      ,[Duration]
      ,[Earliest_Start_Date]
      ,[Latest_Completion_Date]
      ,[Sign_Off_Date]
      ,[Sign_Off_User]
      ,[Parent_Workpackage_ID]
      ,[Material_Cost]
      ,[Baseline_Cum_Total]
      ,[Revised_Date_To_Completion]
      ,[Current_Cum_Total]
      ,[Total_Hours_To_Completion]
      ,[Created_User]
      ,[Allocated_To]
      ,[Job_Number]
      ,[Risk_Created_Date]
      ,[Risk_Review_Date]
      ,[Comment]
      ,[Risk_Created_User]
      ,[Risk_Review_User]
      ,[Location]
      ,[Operator]
      ,[Employees]
      ,[Publics]
      ,[Risk_Sign_Off]
      ,[Risk_Assessment]
      ,[Residual_Score]
      ,[Billing]
      ,[Change_order]
      ,[Actual_Materials]
      ,[Actual_Stock]
      ,[EXT_Workpackage_Contract_Type_ID]
      ,[ScheduleATotal]
      ,[Rework]
      ,[Assignee]
      ,[Override_Markup_Stock]
      ,[Override_Markup_Material]
      ,[Amended_Fixed_Income] FROM [dbo].[EXT_Workpackage]
        WHERE Project_ID = 365", sqlCon);
        sqlCon.Open();
        List<Workpackages> workpackage = new List<Workpackages>();
        SqlDataReader sqlDR = sqlComm.ExecuteReader();
        while (sqlDR.Read())
        {
            workpackage.Add(new Workpackages() { EXT_Workpackage_ID = (int)sqlDR.GetValue(0), Workpackage_Code = (string)sqlDR.GetValue(1),
                Name = (string)sqlDR.GetValue(2), Project_ID = (int)sqlDR.GetValue(3),
                EXT_Workpackage_Status_ID = (int)sqlDR.GetValue(4),
                EXT_Workpackage_Type_ID = (int)sqlDR.GetValue(5),
                Created_Date = (string)sqlDR.GetValue(6),
                Last_Update_Time = (string)sqlDR.GetValue(7),
                Last_Update_User = (int)sqlDR.GetValue(8),
                Description = (string)sqlDR.GetValue(9),
                Drawing_Requirements = (int)sqlDR.GetValue(10),
                Materials = (int)sqlDR.GetValue(11),
                Cutting_List = (int)sqlDR.GetValue(12),
                Duration = (decimal)sqlDR.GetValue(13),
                Earliest_Start_Date = (string)sqlDR.GetValue(14),
                Latest_Completion_Date = (string)sqlDR.GetValue(15),
                Sign_Off_Date = (string)sqlDR.GetValue(16),
                Sign_Off_User = (string)sqlDR.GetValue(17),
                Parent_Workpackage_ID = (int)sqlDR.GetValue(18),
                Material_Cost = (decimal)sqlDR.GetValue(19),
                Baseline_Cum_Total = (decimal)sqlDR.GetValue(20),
                Total_Hours_To_Completion = (decimal)sqlDR.GetValue(21),
                Created_User = (int)sqlDR.GetValue(22),
                Allocated_To = (string)sqlDR.GetValue(23),
                Job_Number = (string)sqlDR.GetValue(24),
                Risk_Created_Date = (string)sqlDR.GetValue(25),
                Risk_Review_Date = (string)sqlDR.GetValue(26),
                Comment = (string)sqlDR.GetValue(27),
                Risk_Created_User = (int)sqlDR.GetValue(28),
                Location = (string)sqlDR.GetValue(29),
                Operator = (int)sqlDR.GetValue(30),
                Employees = (int)sqlDR.GetValue(31),
                Publics = (int)sqlDR.GetValue(32),
                Risk_Sign_Off = (int)sqlDR.GetValue(33),
                Risk_Assessment = (int)sqlDR.GetValue(34),
                Residual_Score = (string)sqlDR.GetValue(35),
                Billing = (int)sqlDR.GetValue(36),
                Change_order = (string)sqlDR.GetValue(37),
                Actual_Materials = (int)sqlDR.GetValue(38),
                Actual_Stock = (int)sqlDR.GetValue(39),
                EXT_Workpackage_Contract_Type_ID = (int)sqlDR.GetValue(40),
                ScheduleATotal = (int)sqlDR.GetValue(41),
                Rework = (int)sqlDR.GetValue(42),
                Assignee = (int)sqlDR.GetValue(43),
                Override_Markup_Stock = (int)sqlDR.GetValue(44),
                Override_Markup_Material = (int)sqlDR.GetValue(45),
                Amended_Fixed_Income = (decimal)sqlDR.GetValue(46),
            });
        }
        sqlCon.Close();
        return new { result = workpackage, count = workpackage.Count };
    }
    //[WebMethod]
    //public static string Save(string changed)
    //{
    //    string changedData = HttpContext.Current.Request.Params["changed"];
    //    JavaScriptSerializer js = new JavaScriptSerializer();
    //    try
    //    {
    //        List<Orders> changes = js.Deserialize<List<Orders>>(changed);
    //        string dbConnectionStr = @"workspace";
    //        SqlConnection sqlCon = new SqlConnection(dbConnectionStr);
    //        foreach (var i in changes)
    //        {
    //            SqlCommand sqlComm = new SqlCommand("UPDATE [Table] SET [Workpackage_Code] = @Workpackage_Code, [Name] = @Name, [Project_ID] = @Project_ID, [@EXT_Workpackage_Status_ID] = @EXT_Workpackage_Status_ID Where [EXT_Workpackage_ID] = @EXT_Workpackage_ID", sqlCon);
    //            sqlComm.Parameters.AddWithValue("@EXT_Workpackage_ID", i.EXT_Workpackage_ID);
    //            sqlComm.Parameters.AddWithValue("@Workpackage_Code", i.Workpackage_Code);
    //            sqlComm.Parameters.AddWithValue("@Name", i.Name);
    //            sqlComm.Parameters.AddWithValue("@Project_ID", i.Project_ID);
    //            sqlComm.Parameters.AddWithValue("@EXT_Workpackage_Status_ID", i.EXT_Workpackage_Status_ID);
    //            sqlCon.Open();
    //            sqlComm.ExecuteNonQuery();
    //            sqlCon.Close();
    //        }
    //        return "Success";
    //    }
    //    catch (Exception ex)
    //    {
    //        return "Failed";
    //    }
    //}
    [Serializable]
    public class Workpackages
    {
        public Workpackages()
        {

        }
        public Workpackages(int EXT_Workpackage_ID, string Workpackage_Code, string Name, int Project_ID, int EXT_Workpackage_Status_ID,
            int EXT_Workpackage_Type_ID, string Created_Date, string Last_Update_Time, int Last_Update_User,
            string Description, int Drawing_Requirements, int Materials, int Cutting_List,
            decimal Duration, string Earliest_Start_Date, string Sign_Off_Date, string Latest_Completion_Date,
            string Sign_Off_User, int Parent_Workpackage_ID, decimal Material_Cost, decimal Baseline_Cum_Total,
            decimal Total_Hours_To_Completion, int Created_User, string Allocated_To, string Job_Number,
            string Risk_Created_Date, string Risk_Review_Date, string Comment, int Risk_Created_User, int Risk_Review_User,
            string Location, int Operator, int Employees, int Publics, int Risk_Sign_Off,
            int Risk_Assessment, string Residual_Score, int Billing, string Change_order, int Actual_Materials,
            int Actual_Stock, int EXT_Workpackage_Contract_Type_ID, int ScheduleATotal, int Rework,
            int Assignee, decimal Override_Markup_Material, decimal Override_Markup_Stock, decimal Amended_Fixed_Income)
        {
            this.EXT_Workpackage_ID = EXT_Workpackage_ID;
            this.Workpackage_Code = AtlasSharedCode.nullifyString(Workpackage_Code);
            this.Name = AtlasSharedCode.nullifyString(Name);
            this.Project_ID = AtlasSharedCode.nullifyInt(Project_ID);
            this.EXT_Workpackage_Status_ID = AtlasSharedCode.nullifyInt(EXT_Workpackage_Status_ID);
            this.EXT_Workpackage_Type_ID = AtlasSharedCode.nullifyInt(EXT_Workpackage_Type_ID);
            this.Created_Date = AtlasSharedCode.nullifyString(Created_Date);
            this.Last_Update_Time = AtlasSharedCode.nullifyString(Last_Update_Time);
            this.Last_Update_User = AtlasSharedCode.nullifyInt(Last_Update_User);
            this.Description = AtlasSharedCode.nullifyString(Description);
            this.Drawing_Requirements = AtlasSharedCode.nullifyInt(Drawing_Requirements);
            this.Materials = AtlasSharedCode.nullifyInt(Materials);
            this.Cutting_List = AtlasSharedCode.nullifyInt(Cutting_List);
            this.Duration = AtlasSharedCode.nullifyDecimal(Duration);
            this.Sign_Off_Date = AtlasSharedCode.nullifyString(Sign_Off_Date);
            this.Earliest_Start_Date = AtlasSharedCode.nullifyString(Earliest_Start_Date);
            this.Latest_Completion_Date = AtlasSharedCode.nullifyString(Latest_Completion_Date);
            this.Sign_Off_User = AtlasSharedCode.nullifyString(Sign_Off_User);
            this.Parent_Workpackage_ID = AtlasSharedCode.nullifyInt(Parent_Workpackage_ID);
            this.Material_Cost = AtlasSharedCode.nullifyDecimal(Material_Cost);
            this.Baseline_Cum_Total = AtlasSharedCode.nullifyDecimal(Baseline_Cum_Total);
            this.Total_Hours_To_Completion = AtlasSharedCode.nullifyDecimal(Total_Hours_To_Completion);
            this.Created_User = AtlasSharedCode.nullifyInt(Created_User);
            this.Allocated_To = AtlasSharedCode.nullifyString(Allocated_To);
            this.Job_Number = AtlasSharedCode.nullifyString(Job_Number);
            this.Risk_Created_Date = AtlasSharedCode.nullifyString(Risk_Created_Date);
            this.Risk_Review_Date = AtlasSharedCode.nullifyString(Risk_Review_Date);
            this.Comment = AtlasSharedCode.nullifyString(Comment);
            this.Risk_Created_User = AtlasSharedCode.nullifyInt(Risk_Created_User);
            this.Risk_Review_User = AtlasSharedCode.nullifyInt(Risk_Review_User);
            this.Location = AtlasSharedCode.nullifyString(Location);
            this.Operator = AtlasSharedCode.nullifyInt(Operator);
            this.Employees = AtlasSharedCode.nullifyInt(Employees);
            this.Publics = AtlasSharedCode.nullifyInt(Publics);
            this.Risk_Sign_Off = AtlasSharedCode.nullifyInt(Risk_Sign_Off);
            this.Risk_Assessment = AtlasSharedCode.nullifyInt(Risk_Assessment);
            this.Residual_Score = AtlasSharedCode.nullifyString(Residual_Score);
            this.Billing = AtlasSharedCode.nullifyInt(Billing);
            this.Change_order = AtlasSharedCode.nullifyString(Change_order);
            this.Actual_Stock = AtlasSharedCode.nullifyDecimal(Actual_Materials);
            this.Actual_Materials = AtlasSharedCode.nullifyDecimal(Actual_Materials);
            this.EXT_Workpackage_Contract_Type_ID = AtlasSharedCode.nullifyInt(EXT_Workpackage_Contract_Type_ID);
            this.ScheduleATotal = AtlasSharedCode.nullifyDecimal(ScheduleATotal);
            this.Rework = AtlasSharedCode.nullifyInt(Rework);
            this.Assignee = AtlasSharedCode.nullifyDecimal(Assignee);
            this.Override_Markup_Stock = AtlasSharedCode.nullifyDecimal(Override_Markup_Material);
            this.Override_Markup_Material = AtlasSharedCode.nullifyDecimal(Override_Markup_Material);
            this.Amended_Fixed_Income = AtlasSharedCode.nullifyDecimal(Amended_Fixed_Income);
        }
        public int? EXT_Workpackage_ID { get; set; }
        public string Workpackage_Code { get; set; }
        public string Name { get; set; }
        public int? Project_ID { get; set; }
        public int? EXT_Workpackage_Status_ID { get; set; }
        public int? EXT_Workpackage_Type_ID { get; set; }
        public string Created_Date { get; set; }
        public string Last_Update_Time { get; set; }
        public int? Last_Update_User { get; set; }
        public string Description { get; set; }
        public int? Drawing_Requirements { get; set; }
        public int? Materials { get; set; }
        public int? Cutting_List { get; set; }
        public decimal? Duration { get; set; }
        public string Earliest_Start_Date { get; set; }
        public string Latest_Completion_Date { get; set; }
        public string Sign_Off_Date { get; set; }
        public string Sign_Off_User { get; set; }
        public int? Parent_Workpackage_ID { get; set; }
        public decimal? Material_Cost { get; set; }
        public decimal? Baseline_Cum_Total { get; set; }
        public decimal? Total_Hours_To_Completion { get; set; }
        public int? Created_User { get; set; }
        public string Allocated_To { get; set; }
        public string Job_Number { get; set; }
        public string Risk_Created_Date { get; set; }
        public string Risk_Review_Date { get; set; }
        public string Comment { get; set; }
        public int? Risk_Created_User { get; set; }
        public int? Risk_Review_User { get; set; }
        public string Location { get; set; }
        public int? Operator { get; set; }
        public int? Employees { get; set; }
        public int? Publics { get; set; }
        public int? Risk_Sign_Off { get; set; }
        public int? Risk_Assessment { get; set; }
        public string Residual_Score { get; set; }
        public int? Billing { get; set; }
        public string Change_order { get; set; }
        public decimal? Actual_Materials { get; set; }
        public decimal? Actual_Stock { get; set; }
        public int? EXT_Workpackage_Contract_Type_ID { get; set; }
        public decimal? ScheduleATotal { get; set; }
        public int? Rework { get; set; }
        public decimal? Assignee { get; set; }
        public decimal? Override_Markup_Stock { get; set; }
        public decimal? Override_Markup_Material { get; set; }
        public decimal? Amended_Fixed_Income { get; set; }
    }
}
